package uk.me.nxg.unity;

class UnitWriterCds extends UnitWriter {

    public UnitWriterCds(UnitExpr ue) {
        super(ue);
    }

    public String write() {
        StringBuilder sb = new StringBuilder();
        boolean first = true;

        try {
            if (ue.getLogFactor() != 0.0) {
                double l = ue.getLogFactor();
                if (l == Math.floor(l) && (l < -2.0 || l > 2.0)) {
                    sb.append("10");
                    if (ue.getLogFactor() > 0.0) {
                        sb.append('+');
                    }
                    writeNumber(sb, ue.getLogFactor());
                } else {
                    writeNumber(sb, Math.pow(10,l));
                }
            }
            for (OneUnit u : ue) {
                double e = u.getExponent();
                if (e == 1.0) {
                    if (!first) {
                        sb.append('.');
                    }
                    sb.append(u.unitString(UnitParser.CDS));
                } else if (e < 0.0) {
                    sb.append('/').append(u.unitString(UnitParser.CDS));
                    if (e != -1.0) {
                        writeNumber(sb, -e);
                    }
                } else {
                    // e is positive and not 1.0
                    if (!first) {
                        sb.append('.');
                    }
                    sb.append(u.unitString(UnitParser.CDS));
                    writeNumber(sb, e);
                }
                first = false;
            }
            return sb.toString();
        } catch (UnitParserException e) {
            throw new AssertionError("units system failed to recognise built-in syntax CDS: " + e);
        }
    }

    void writeNumber(StringBuilder sb, double d) {
        writeNumber(sb, d, false, false, false);
    }
}
